# options for analysis running
run:
  # default concurrency is a available CPU number
  concurrency: 4

  # timeout for analysis, e.g. 30s, 5m, default is 1m
  deadline: 10m

  # exit code when at least one issue was found, default is 1
  issues-exit-code: 1

  # include test files or not, default is true
  tests: true

  # list of build tags, all linters use it. Default is empty list.
  build-tags:
    - unit

  # which dirs to skip: they won't be analyzed;
  # can use regexp here: generated.*, regexp is applied on full path;
  # default value is empty list, but next dirs are always skipped independently
  # from this option's value:
  # third_party$, testdata$, examples$, Godeps$, builtin$
  skip-dirs:
    - ^pkg.*client.*clientset.*versioned.*
    - ^pkg.*client.*informers.*externalversions.*
    - ^pkg.*proto.*

  # which files to skip: they will be analyzed, but issues from them
  # won't be reported. Default value is empty list, but there is
  # no need to include all autogenerated files, we confidently recognize
  # autogenerated files. If it's not please let us know.
  skip-files:
  #  - ".*\\.my\\.go$"
  #  - lib/bad.go

# output configuration options
output:
  # colored-line-number|line-number|json|tab|checkstyle, default is "colored-line-number"
  format: tab

  # print lines of code with issue, default is true
  print-issued-lines: true

  # print linter name in the end of issue text, default is true
  print-linter-name: true


# all available settings of specific linters
linters-settings:
  errcheck:
    # report about not checking of errors in type assetions: `a := b.(MyStruct)`;
    # default is false: such cases aren't reported by default.
    check-type-assertions: false

    # report about assignment of errors to blank identifier: `num, _ := strconv.Atoi(numStr)`;
    # default is false: such cases aren't reported by default.
    check-blank: false

    # [deprecated] comma-separated list of pairs of the form pkg:regex
    # the regex is used to ignore names within pkg. (default "fmt:.*").
    # see https://github.com/kisielk/errcheck#the-deprecated-method for details
    ignore: fmt:.*,io/ioutil:^Read.*

    # path to a file containing a list of functions to exclude from checking
    # see https://github.com/kisielk/errcheck#excluding-functions for details
    exclude:

  funlen:
    lines: 60
    statements: 40

  govet:
    # report about shadowed variables
    check-shadowing: true

    # settings per analyzer
    settings:
      printf: # analyzer name, run `go tool vet help` to see all analyzers
        funcs: # run `go tool vet help printf` to see available settings for `printf` analyzer
          - (github.com/golangci/golangci-lint/pkg/logutils.Log).Infof
          - (github.com/golangci/golangci-lint/pkg/logutils.Log).Warnf
          - (github.com/golangci/golangci-lint/pkg/logutils.Log).Errorf
          - (github.com/golangci/golangci-lint/pkg/logutils.Log).Fatalf

    # enable or disable analyzers by name
    enable:
      - atomicalign
    enable-all: false
    disable:
      - shadow
    disable-all: false
  golint:
    # minimal confidence for issues, default is 0.8
    min-confidence: 0.8
  gofmt:
    # simplify code: gofmt with `-s` option, true by default
    simplify: true
  goimports:
    # put imports beginning with prefix after 3rd-party packages;
    # it's a comma-separated list of prefixes
    local-prefixes: github.com/dapr/
  gocyclo:
    # minimal code complexity to report, 30 by default (but we recommend 10-20)
    min-complexity: 10
  gocognit:
    # minimal code complexity to report, 30 by default (but we recommend 10-20)
    min-complexity: 10
  maligned:
    # print struct with more effective memory layout or not, false by default
    suggest-new: true
  dupl:
    # tokens count to trigger issue, 150 by default
    threshold: 100
  goconst:
    # minimal length of string constant, 3 by default
    min-len: 3
    # minimal occurrences count to trigger, 3 by default
    min-occurrences: 5
  depguard:
    rules:
      main:
        deny:
          - pkg: "github.com/Sirupsen/logrus"
            desc: "must use github.com/dapr/kit/logger"
          - pkg: "github.com/agrea/ptr"
            desc: "must use github.com/dapr/kit/ptr"
          - pkg: "go.uber.org/atomic"
            desc: "must use sync/atomic"
          - pkg: "golang.org/x/net/context"
            desc: "must use context"
          - pkg: "github.com/pkg/errors"
            desc: "must use standard library (errors package and/or fmt.Errorf)"
          - pkg: "github.com/go-chi/chi$"
            desc: "must use github.com/go-chi/chi/v5"
          - pkg: "github.com/cenkalti/backoff$"
            desc: "must use github.com/cenkalti/backoff/v4"
          - pkg: "github.com/cenkalti/backoff/v2"
            desc: "must use github.com/cenkalti/backoff/v4"
          - pkg: "github.com/cenkalti/backoff/v3"
            desc: "must use github.com/cenkalti/backoff/v4"
          - pkg: "github.com/benbjohnson/clock"
            desc: "must use k8s.io/utils/clock"
          - pkg: "github.com/ghodss/yaml"
            desc: "must use sigs.k8s.io/yaml"
          - pkg: "gopkg.in/yaml.v2"
            desc: "must use gopkg.in/yaml.v3"
          - pkg: "github.com/golang-jwt/jwt"
            desc: "must use github.com/lestrrat-go/jwx/v2"
          - pkg: "github.com/golang-jwt/jwt/v2"
            desc: "must use github.com/lestrrat-go/jwx/v2"
          - pkg: "github.com/golang-jwt/jwt/v3"
            desc: "must use github.com/lestrrat-go/jwx/v2"
          - pkg: "github.com/golang-jwt/jwt/v4"
            desc: "must use github.com/lestrrat-go/jwx/v2"
          - pkg: "github.com/gogo/status"
            desc: "must use google.golang.org/grpc/status"
          - pkg: "github.com/gogo/protobuf"
            desc: "must use google.golang.org/protobuf"
          - pkg: "github.com/lestrrat-go/jwx/jwa"
            desc: "must use github.com/lestrrat-go/jwx/v2"
          - pkg: "github.com/lestrrat-go/jwx/jwt"
            desc: "must use github.com/lestrrat-go/jwx/v2"
          - pkg: "github.com/labstack/gommon/log"
            desc: "must use github.com/dapr/kit/logger"
          - pkg: "github.com/gobuffalo/logger"
            desc: "must use github.com/dapr/kit/logger"
  misspell:
    # Correct spellings using locale preferences for US or UK.
    # Default is to use a neutral variety of English.
    # Setting locale to US will correct the British spelling of 'colour' to 'color'.
    locale: default
    ignore-words:
      - someword
  lll:
    # max line length, lines longer will be reported. Default is 120.
    # '\t' is counted as 1 character by default, and can be changed with the tab-width option
    line-length: 120
    # tab width in spaces. Default to 1.
    tab-width: 1
  unparam:
    # Inspect exported functions, default is false. Set to true if no external program/library imports your code.
    # XXX: if you enable this setting, unparam will report a lot of false-positives in text editors:
    # if it's called for subdir of a project it can't find external interfaces. All text editor integrations
    # with golangci-lint call it on a directory with the changed file.
    check-exported: false
  nakedret:
    # make an issue if func has more lines of code than this setting and it has naked returns; default is 30
    max-func-lines: 30
  nolintlint:
    allow-unused: true
  prealloc:
    # XXX: we don't recommend using this linter before doing performance profiling.
    # For most programs usage of prealloc will be a premature optimization.

    # Report preallocation suggestions only on simple loops that have no returns/breaks/continues/gotos in them.
    # True by default.
    simple: true
    range-loops: true # Report preallocation suggestions on range loops, true by default
    for-loops: false # Report preallocation suggestions on for loops, false by default
  gocritic:
    # Which checks should be enabled; can't be combined with 'disabled-checks';
    # See https://go-critic.github.io/overview#checks-overview
    # To check which checks are enabled run `GL_DEBUG=gocritic golangci-lint run`
    # By default list of stable checks is used.
    enabled-checks:

    # Which checks should be disabled; can't be combined with 'enabled-checks'; default is empty
    disabled-checks:
      - regexpMust
      - rangeValCopy
      - hugeParam
      - ifElseChain
      - singleCaseSwitch
      - exitAfterDefer

    # Enable multiple checks by tags, run `GL_DEBUG=gocritic golangci-lint run` to see all tags and checks.
    # Empty list by default. See https://github.com/go-critic/go-critic#usage -> section "Tags".
    enabled-tags:
      - performance

    settings: # settings passed to gocritic
      captLocal: # must be valid enabled check name
        paramsOnly: true
  godox:
    # report any comments starting with keywords, this is useful for TODO or FIXME comments that
    # might be left in the code accidentally and should be resolved before merging
    keywords: # default keywords are TODO, BUG, and FIXME, these can be overwritten by this setting
      - NOTE
      - OPTIMIZE # marks code that should be optimized before merging
      - HACK # marks hack-arounds that should be removed before merging
  godot:
    exclude:
      - 'nosec'
    capital: false
    scope: all
  dogsled:
    # checks assignments with too many blank identifiers; default is 2
    max-blank-identifiers: 2

  whitespace:
    multi-if: false   # Enforces newlines (or comments) after every multi-line if statement
    multi-func: false # Enforces newlines (or comments) after every multi-line function signature

  wsl:
    # If true append is only allowed to be cuddled if appending value is
    # matching variables, fields or types on line above. Default is true.
    strict-append: true
    # Allow calls and assignments to be cuddled as long as the lines have any
    # matching variables, fields or types. Default is true.
    allow-assign-and-call: true
    # Allow multiline assignments to be cuddled. Default is true.
    allow-multiline-assign: true
    # Allow case blocks to end with a whitespace.
    allow-case-traling-whitespace: true
    # Allow declarations (var) to be cuddled.
    allow-cuddle-declarations: false

linters:
  fast: false
  enable-all: true
  disable:
    # TODO Enforce the below linters later
    - dupl
    - nonamedreturns
    - errcheck
    - funlen
    - goconst
    - gochecknoglobals
    - gochecknoinits
    - gocyclo
    - gocognit
    - nosnakecase
    - varcheck
    - structcheck
    - deadcode
    - godox
    - interfacer
    - lll
    - maligned
    - scopelint
    - unparam
    - wsl
    - gomnd
    - testpackage
    - nestif
    - nlreturn
    - noctx
    - gci
    - golint
    - tparallel
    - paralleltest
    - wrapcheck
    - tagliatelle
    - ireturn
    - exhaustive
    - exhaustivestruct
    - exhaustruct
    - errchkjson
    - contextcheck
    - gomoddirectives
    - godot
    - cyclop
    - varnamelen
    - gosec
    - tagalign
    - errorlint
    - forcetypeassert
    - ifshort
    - maintidx
    - nilnil
    - predeclared
    - tenv
    - thelper
    - wastedassign
    - containedctx
    - gosimple
    - forbidigo
